// 
//  ode.cpp written by Kenji Shimada
//  Problem Set 12 Sample Code 
// 

#include  "ode.h"


int main(int argc, char *argv[]) {     

	double	q[N][6];	// matrix to store the state of the system
	double	f[6];		// dq/dt = f
	double	l, c;		// variables for intermediate results
	int		i, j;		// loop counters


	cout << "\n>>  24-311:Numerical Methods -- ODE <<\n\n";

	//  Check the number of arguments 
	if (argc == 7) {
		//Set an initial location and velocity
		for(i=0; i<6; i++) q[0][i] = atof(argv[i+1]);     
	} else {
		cerr << "usage: \"ode x0 y0 z0 vx0 vy0 vz0\" \n";
		exit(-1); 
	}


	//  Open output wrl file
	ofstream outFile;                   
	outFile.open ("output.wrl", ios::out);
	if (!outFile) {
		cerr << "Cannot open this file for output.\n";
		exit (-1);
	}


	/////////////////////////////////////////////////////////////////
	//The following sample code integrates the equation of motion
	//using the Euler's method.  You are asked to replace it with 
	//the fourth order Runge-Kutta method.
	/////////////////////////////////////////////////////////////////
	for (i=0; i<N-1; i++){
		l = sqrt( q[i][0]*q[i][0] + q[i][1]*q[i][1] + q[i][2]*q[i][2] );
		c = - K * (l - L0) / (l*M);
		f[0] = q[i][3];
		f[1] = q[i][4];
		f[2] = q[i][5];
		f[3] = c * q[i][0];
		f[4] = c * q[i][1] - G;
		f[5] = c * q[i][2];
		for (j=0; j<6; j++)
			q[i+1][j] = q[i][j] + H*f[j];
		cout << q[i][0] << "  "  << q[i][1] << "  " << q[i][2] << "\n";
	}


	//  Create output wrl file
	vrml_ode (outFile, MY_NAME, q);
	
	//  Close the output wrl file
	outFile.close ();

	cout.flush();

	return 0;
}
